package co.com.certicamara.reporte.lambda.config;

import javax.inject.Singleton;

@Singleton
public class Query {

    public String tipoOpQuery = "SELECT OPC.ORDEN_PEDIDO_ID, PN.MODELO_VOLUMEN_ID FROM CEH_ORDEN_PEDIDO_CUPO AS OPC " +
            "JOIN CEH_VOLUMEN_PROYECTO_NIT AS PN ON OPC.VOLUMEN_ID = PN.VOLUMEN_ID " +
            "WHERE OPC.ORDEN_PEDIDO_ID IN ";

    public String tipo1Query = "SELECT DISTINCT " +
            "ST.ORDEN_PEDIDO_ID, " +
            "            ST.SOLICITUD_TITULAR_ID, " +
            "            ISNULL(ST.PRIMER_NOMBRE, '')  + ' ' + ISNULL(ST.SEGUNDO_NOMBRE, '') + ' ' + ISNULL(ST.PRIMER_APELLIDO, '') + ' ' + ISNULL(ST.SEGUNDO_APELLIDO, '') AS NOMBRE_COMPLETO,                       " +
            "            ST.NUMERO_IDENTIFICACION as NUMERO_IDENTIFICACION_TITULAR, " +
            "SE.RAZON_SOCIAL AS EMPRESA, " +
            "            OP.NUMERO_IDENTIFICACION_CLIENTE AS NIT, " +
            "VPN.NUMERO_CONTRATO, " +
            "VPN.NOMBRE_ENTIDAD AS RAZON_SOCIAL_CONTRATO, " +
            "PRO.NOMBRE_PROYECTO, " +
            "vpn.FECHA_PLAZO_INICIAL, vpn.FECHA_PLAZO_FINAL, " +
            "VPN.NUMERO_IDENTIFICACION_CLIENTE AS NIT_CONTRATO, " +
            "PROY.APLICA_P12_SN, " +
            "PROY.NOMBRE_PROYECTO as NOMBRE_PROTECTO_SOLICITUD, " +
            "VPN.VOLUMEN_ASIGNADO AS CUPO_ASIGNADO, " +
            "VPN.VOLUMEN_ASIGNADO-F.CANT_TOTAL_PROCESO+F.CANT_RECHAZADA_PROCESO AS CUPOS_DISPONIBLES, " +
            "VPN.VOLUMEN_ASIGNADO - VPN.VOLUMEN_ASIGNADO as PENDIENTE_X_REGISTRAR, " +
            "RM.DYNAMICS_ID as CATEGORIA_DE_VENTAS " +
            "FROM CEH_VOLUMEN_PROYECTO_NIT  VPN " +
            "join CEH_ORDEN_PEDIDO_CUPO as OPC on VPN.VOLUMEN_ID = opc.VOLUMEN_ID " +
            "join CEH_SOLICITUD_TITULAR as ST on OPc.ORDEN_PEDIDO_ID = st.ORDEN_PEDIDO_ID " +
            "join CEH_ORDEN_PEDIDO as OP on OP.ORDEN_PEDIDO_ID = opc.ORDEN_PEDIDO_ID " +
            "INNER JOIN DYNAMICS.CEH_RESULTADO_METODO RM ON RM.ORDEN_PEDIDO_ID = OP.ORDEN_PEDIDO_ID " +
            "JOIN dbo.CEB_PROYECTO AS PROY ON OP.PROYECTO_ID = PROY.PROYECTO_ID " +
            "JOIN CEB_PROYECTO PRO ON PRO.PROYECTO_ID = OP.PROYECTO_ID " +
            "JOIN dbo.CEH_SOLICITUD_EMPRESA AS SE ON ST.ORDEN_PEDIDO_ID = SE.ORDEN_PEDIDO_ID " +
            "CROSS APPLY (SELECT * FROM DBO.CEF_CANTIDADES_CONSUMO_CUPOS(VPN.VOLUMEN_ID)) AS F " +
            "WHERE VPN.VOLUMEN_ID=opc.VOLUMEN_ID and opc.ORDEN_PEDIDO_ID in";

    public String tipo2Query = "SELECT " +
            "                      ST.ORDEN_PEDIDO_ID,  " +
            "                      ST.SOLICITUD_TITULAR_ID,  " +
            "                      ISNULL(ST.PRIMER_NOMBRE, '')  + ' ' + ISNULL(ST.SEGUNDO_NOMBRE, '') + ' ' + ISNULL(ST.PRIMER_APELLIDO, '') + ' ' + ISNULL(ST.SEGUNDO_APELLIDO, '') AS NOMBRE_COMPLETO,                        " +
            "                      ST.NUMERO_IDENTIFICACION as NUMERO_IDENTIFICACION_TITULAR,  " +
            "                      SE.RAZON_SOCIAL AS EMPRESA,  " +
            "                      OP.NUMERO_IDENTIFICACION_CLIENTE AS NIT,  " +
            "                      VPN.NUMERO_CONTRATO,  " +
            "                      VPN.NOMBRE_ENTIDAD AS RAZON_SOCIAL_CONTRATO,  " +
            "                      PRO.NOMBRE_PROYECTO,  " +
            "                      vpn.FECHA_PLAZO_INICIAL, vpn.FECHA_PLAZO_FINAL,  " +
            "                      VPN.NUMERO_IDENTIFICACION_CLIENTE AS NIT_CONTRATO,  " +
            "                      PROB.APLICA_P12_SN,   " +
            "                      PROY.NOMBRE_PROYECTO as NOMBRE_PROTECTO_SOLICITUD,  " +
            "vpn.VOLUMEN_ASIGNADO as CUPO_ASIGNADO,  " +
            "(select SUM(VOLUMEN_ASIGNADO) from CEH_NIT_ENTIDADES WHERE VOLUMEN_ID = VPN.VOLUMEN_ID ) - F1.CANT_TOTAL_PROCESO+F1.CANT_RECHAZADA_PROCESO as CANTIDAD_DISPONIBLE,  " +
            "vpn.VOLUMEN_ASIGNADO - (select SUM(VOLUMEN_ASIGNADO) from CEH_NIT_ENTIDADES WHERE VOLUMEN_ID = VPN.VOLUMEN_ID ) as PENDIENTE_X_REGISTRAR,  " +
            "RM.DYNAMICS_ID as CATEGORIA_DE_VENTAS  " +
            "FROM    dbo.CEH_ORDEN_PEDIDO AS OP  " +
            "INNER JOIN DYNAMICS.CEH_RESULTADO_METODO RM ON RM.ORDEN_PEDIDO_ID = OP.ORDEN_PEDIDO_ID  " +
            "INNER JOIN dbo.CEH_SOLICITUD_TITULAR AS ST  ON ST.ORDEN_PEDIDO_ID = OP.ORDEN_PEDIDO_ID " +
            "LEFT OUTER JOIN dbo.CEH_SOLICITUD_EMPRESA AS SE ON ST.ORDEN_PEDIDO_ID = SE.ORDEN_PEDIDO_ID  " +
            "LEFT OUTER JOIN dbo.CEB_PROYECTO AS PROY ON OP.PROYECTO_ID = PROY.PROYECTO_ID  " +
            "LEFT OUTER JOIN CEH_ORDEN_PEDIDO_CUPO OPC ON OP.ORDEN_PEDIDO_ID = OPC.ORDEN_PEDIDO_ID  " +
            "LEFT OUTER JOIN CEH_VOLUMEN_PROYECTO_NIT VPN ON VPN.VOLUMEN_ID = OPC.VOLUMEN_ID  " +
            "Left JOIN CEB_PROYECTO PRO ON PRO.PROYECTO_ID = OP.PROYECTO_ID  " +
            "INNER JOIN CEH_NIT_ENTIDADES AS NE ON NE.VOLUMEN_ID=VPN.VOLUMEN_ID  " +
            "CROSS APPLY (SELECT * FROM DBO.CEF_CANTIDADES_CONSUMO_CUPOS_MULTI(VPN.VOLUMEN_ID,NE.NUMERO_IDENTIFICACION_CLIENTE)) AS F  " +
            "CROSS APPLY (SELECT * FROM DBO.CEF_CANTIDADES_CONSUMO_CUPOS(VPN.VOLUMEN_ID)) AS F1  " +
            "WHERE NE.NUMERO_IDENTIFICACION_CLIENTE=OP.NUMERO_IDENTIFICACION_CLIENTE  " +
            "AND VPN.MODELO_VOLUMEN_ID = vpn.MODELO_VOLUMEN_ID  " +
            "and OP.ORDEN_PEDIDO_ID in ";

    public String grupoTipo2Query = " group by ST.ORDEN_PEDIDO_ID, SOLICITUD_TITULAR_ID, ST.PRIMER_NOMBRE, ST.SEGUNDO_NOMBRE, ST.PRIMER_APELLIDO, ST.SEGUNDO_APELLIDO,                  " +
            "                      ST.NUMERO_IDENTIFICACION,  " +
            "                      SE.RAZON_SOCIAL,  " +
            "                      OP.NUMERO_IDENTIFICACION_CLIENTE,  " +
            "                      PROY.NOMBRE_PROYECTO ,  " +
            " PROY.APLICA_P12_SN  " +
            ",VPN.NUMERO_CONTRATO, VPN.NOMBRE_ENTIDAD,  " +
            "VPN.NUMERO_IDENTIFICACION_CLIENTE ,  " +
            "PRO.NOMBRE_PROYECTO,  " +
            "NE.VOLUMEN_ASIGNADO ,  " +
            "vpn.VOLUMEN_ASIGNADO,  " +
            "F.CANT_TOTAL_PROCESO,  " +
            "F.CANT_RECHAZADA_PROCESO,  " +
            "F1.CANT_TOTAL_PROCESO,  " +
            "F1.CANT_RECHAZADA_PROCESO,  " +
            "vpn.FECHA_PLAZO_INICIAL,  " +
            "vpn.FECHA_PLAZO_FINAL,  " +
            "NE.VOLUMEN_ASIGNADO,  " +
            "vpn.VOLUMEN_ID,  " +
            "RM.DYNAMICS_ID;";

    public String tipo1QueryLimit = "SELECT DISTINCT TOP 50 " +
            "ST.ORDEN_PEDIDO_ID, " +
            "            ST.SOLICITUD_TITULAR_ID, " +
            "            ISNULL(ST.PRIMER_NOMBRE, '')  + ' ' + ISNULL(ST.SEGUNDO_NOMBRE, '') + ' ' + ISNULL(ST.PRIMER_APELLIDO, '') + ' ' + ISNULL(ST.SEGUNDO_APELLIDO, '') AS NOMBRE_COMPLETO,                       " +
            "            ST.NUMERO_IDENTIFICACION as NUMERO_IDENTIFICACION_TITULAR, " +
            "SE.RAZON_SOCIAL AS EMPRESA, " +
            "            OP.NUMERO_IDENTIFICACION_CLIENTE AS NIT, " +
            "VPN.NUMERO_CONTRATO, " +
            "VPN.NOMBRE_ENTIDAD AS RAZON_SOCIAL_CONTRATO, " +
            "PRO.NOMBRE_PROYECTO, " +
            "vpn.FECHA_PLAZO_INICIAL, vpn.FECHA_PLAZO_FINAL, " +
            "VPN.NUMERO_IDENTIFICACION_CLIENTE AS NIT_CONTRATO, " +
            "PROY.APLICA_P12_SN, " +
            "PROY.NOMBRE_PROYECTO as NOMBRE_PROTECTO_SOLICITUD, " +
            "VPN.VOLUMEN_ASIGNADO AS CUPO_ASIGNADO, " +
            "VPN.VOLUMEN_ASIGNADO-F.CANT_TOTAL_PROCESO+F.CANT_RECHAZADA_PROCESO AS CUPOS_DISPONIBLES, " +
            "VPN.VOLUMEN_ASIGNADO - VPN.VOLUMEN_ASIGNADO as PENDIENTE_X_REGISTRAR, " +
            "RM.DYNAMICS_ID as CATEGORIA_DE_VENTAS " +
            "FROM CEH_VOLUMEN_PROYECTO_NIT  VPN " +
            "join CEH_ORDEN_PEDIDO_CUPO as OPC on VPN.VOLUMEN_ID = opc.VOLUMEN_ID " +
            "join CEH_SOLICITUD_TITULAR as ST on OPc.ORDEN_PEDIDO_ID = st.ORDEN_PEDIDO_ID " +
            "join CEH_ORDEN_PEDIDO as OP on OP.ORDEN_PEDIDO_ID = opc.ORDEN_PEDIDO_ID " +
            "INNER JOIN DYNAMICS.CEH_RESULTADO_METODO RM ON RM.ORDEN_PEDIDO_ID = OP.ORDEN_PEDIDO_ID " +
            "JOIN dbo.CEB_PROYECTO AS PROY ON OP.PROYECTO_ID = PROY.PROYECTO_ID " +
            "JOIN CEB_PROYECTO PRO ON PRO.PROYECTO_ID = OP.PROYECTO_ID " +
            "JOIN dbo.CEH_SOLICITUD_EMPRESA AS SE ON ST.ORDEN_PEDIDO_ID = SE.ORDEN_PEDIDO_ID " +
            "CROSS APPLY (SELECT * FROM DBO.CEF_CANTIDADES_CONSUMO_CUPOS(VPN.VOLUMEN_ID)) AS F " +
            "WHERE VPN.VOLUMEN_ID=opc.VOLUMEN_ID ";

    public String tipo2QueryLimit = "SELECT TOP 50 " +
            "                      ST.ORDEN_PEDIDO_ID,  " +
            "                      ST.SOLICITUD_TITULAR_ID,  " +
            "                      ISNULL(ST.PRIMER_NOMBRE, '')  + ' ' + ISNULL(ST.SEGUNDO_NOMBRE, '') + ' ' + ISNULL(ST.PRIMER_APELLIDO, '') + ' ' + ISNULL(ST.SEGUNDO_APELLIDO, '') AS NOMBRE_COMPLETO,                        " +
            "                      ST.NUMERO_IDENTIFICACION as NUMERO_IDENTIFICACION_TITULAR,  " +
            "                      SE.RAZON_SOCIAL AS EMPRESA,  " +
            "                      OP.NUMERO_IDENTIFICACION_CLIENTE AS NIT,  " +
            "                      VPN.NUMERO_CONTRATO,  " +
            "                      VPN.NOMBRE_ENTIDAD AS RAZON_SOCIAL_CONTRATO,  " +
            "                      PRO.NOMBRE_PROYECTO,  " +
            "                      vpn.FECHA_PLAZO_INICIAL, vpn.FECHA_PLAZO_FINAL,  " +
            "                      VPN.NUMERO_IDENTIFICACION_CLIENTE AS NIT_CONTRATO,  " +
            "                      PROB.APLICA_P12_SN,   " +
            "                      PROY.NOMBRE_PROYECTO as NOMBRE_PROTECTO_SOLICITUD,  " +
            "vpn.VOLUMEN_ASIGNADO as CUPO_ASIGNADO,  " +
            "(select SUM(VOLUMEN_ASIGNADO) from CEH_NIT_ENTIDADES WHERE VOLUMEN_ID = VPN.VOLUMEN_ID ) - F1.CANT_TOTAL_PROCESO+F1.CANT_RECHAZADA_PROCESO as CANTIDAD_DISPONIBLE,  " +
            "vpn.VOLUMEN_ASIGNADO - (select SUM(VOLUMEN_ASIGNADO) from CEH_NIT_ENTIDADES WHERE VOLUMEN_ID = VPN.VOLUMEN_ID ) as PENDIENTE_X_REGISTRAR,  " +
            "RM.DYNAMICS_ID as CATEGORIA_DE_VENTAS  " +
            "FROM    dbo.CEH_ORDEN_PEDIDO AS OP  " +
            "INNER JOIN DYNAMICS.CEH_RESULTADO_METODO RM ON RM.ORDEN_PEDIDO_ID = OP.ORDEN_PEDIDO_ID  " +
            "INNER JOIN dbo.CEH_SOLICITUD_TITULAR AS ST  ON ST.ORDEN_PEDIDO_ID = OP.ORDEN_PEDIDO_ID " +
            "LEFT OUTER JOIN dbo.CEH_SOLICITUD_EMPRESA AS SE ON ST.ORDEN_PEDIDO_ID = SE.ORDEN_PEDIDO_ID  " +
            "LEFT OUTER JOIN dbo.CEB_PROYECTO AS PROY ON OP.PROYECTO_ID = PROY.PROYECTO_ID  " +
            "LEFT OUTER JOIN CEH_ORDEN_PEDIDO_CUPO OPC ON OP.ORDEN_PEDIDO_ID = OPC.ORDEN_PEDIDO_ID  " +
            "LEFT OUTER JOIN CEH_VOLUMEN_PROYECTO_NIT VPN ON VPN.VOLUMEN_ID = OPC.VOLUMEN_ID  " +
            "Left JOIN CEB_PROYECTO PRO ON PRO.PROYECTO_ID = OP.PROYECTO_ID  " +
            "INNER JOIN CEH_NIT_ENTIDADES AS NE ON NE.VOLUMEN_ID=VPN.VOLUMEN_ID  " +
            "CROSS APPLY (SELECT * FROM DBO.CEF_CANTIDADES_CONSUMO_CUPOS_MULTI(VPN.VOLUMEN_ID,NE.NUMERO_IDENTIFICACION_CLIENTE)) AS F  " +
            "CROSS APPLY (SELECT * FROM DBO.CEF_CANTIDADES_CONSUMO_CUPOS(VPN.VOLUMEN_ID)) AS F1  " +
            "WHERE NE.NUMERO_IDENTIFICACION_CLIENTE=OP.NUMERO_IDENTIFICACION_CLIENTE  " +
            "AND VPN.MODELO_VOLUMEN_ID = vpn.MODELO_VOLUMEN_ID  " +
            "group by ST.ORDEN_PEDIDO_ID, SOLICITUD_TITULAR_ID, ST.PRIMER_NOMBRE, ST.SEGUNDO_NOMBRE, ST.PRIMER_APELLIDO, ST.SEGUNDO_APELLIDO,                  " +
            "                      ST.NUMERO_IDENTIFICACION,  " +
            "                      SE.RAZON_SOCIAL,  " +
            "                      OP.NUMERO_IDENTIFICACION_CLIENTE,  " +
            "                      PROY.NOMBRE_PROYECTO ,  " +
            " PROY.APLICA_P12_SN  " +
            ",VPN.NUMERO_CONTRATO, VPN.NOMBRE_ENTIDAD,  " +
            "VPN.NUMERO_IDENTIFICACION_CLIENTE ,  " +
            "PRO.NOMBRE_PROYECTO,  " +
            "NE.VOLUMEN_ASIGNADO ,  " +
            "vpn.VOLUMEN_ASIGNADO,  " +
            "F.CANT_TOTAL_PROCESO,  " +
            "F.CANT_RECHAZADA_PROCESO,  " +
            "F1.CANT_TOTAL_PROCESO,  " +
            "F1.CANT_RECHAZADA_PROCESO,  " +
            "vpn.FECHA_PLAZO_INICIAL,  " +
            "vpn.FECHA_PLAZO_FINAL,  " +
            "NE.VOLUMEN_ASIGNADO,  " +
            "vpn.VOLUMEN_ID,  " +
            "RM.DYNAMICS_ID;";

}
